Subject: bug#35591: Segfault on flatpak remote-add

From: Jonathan Frederickson <[email-masked]>
Date: Sun, 05 May 2019 18:47:57 -0400

On Sunday, May 5, 2019 6:36:06 PM EDT Mark H Weaver wrote:
> My knowledge of Flatpak is weak, but in general, foreign pre-compiled
> binaries will not work on Guix unless they are statically linked.
> Traditional dynamically-linked executables expect to find a dynamic
> linker and system shared libraries in /lib or /lib64, which do not exist
> on a Guix system.  It is also fairly common for foreign binaries to
> depend on standard files and programs in /usr, /bin, and /sbin, none of
> which are present on a Guix system except for /bin/sh.

I believe Flatpak applications are statically linked. (Or rather, individual 
applications may be dynamically linked, but they are eventually combined with 
a full OS image similarly to how Docker works.)

> I'm sorry I don't have a better answer for you, but Guix was not
> designed to run foreign pre-compiled binaries.  If that's important to
> you, it might be that Guix is not a good fit for you.

It's not the most important thing to me; it may end up being one more reason 
for me to start attempting to package things for Guix! But it would still be 
nice to be able to run the same tooling that e.g. some Gnome developers are 
using to publish their apps across distros. (And the fact that Flatpak is 
packaged for Guix seems to imply that it should be possible to use it here.)

> However, if your goal is to run Guix-compiled programs in a sandbox,
> that's something we are certainly very interested in, and we could use
> help.  We have "guix container" as a building block, and I know that
> some Guix users have experimented with running e.g. GNU IceCat within a
> container.  I don't know the current status of those efforts.  Hopefully
> someone more knowledgable in this area will chime in.

While this isn't my immediate goal, this is also something that I'm interested 
in, if someone else knows more about this!